/*
    Function prototypes for use with Storm.dll
    Storm.h, Storm.lib, and Storm.exp created by ShadowFlare

    This file requires the Storm.lib or Storm.exp file
*/

#ifndef STORM_H
#define STORM_H

#include <windows.h>

#ifdef STORM_EXPORTS
#define STORM __declspec(dllexport)
#else
#define STORM __declspec(dllimport)
#endif

#ifdef __cplusplus
extern "C" {
#endif

#define SFILE_OPEN_HARD_DISK_FILE 0x0000 //Open archive without regard to the drive type it resides on
#define SFILE_OPEN_CD_ROM_FILE    0x0001 //Open the archive only if it is on a CD-ROM

#define SFILE_SEARCH_CURRENT_ONLY 0x00 //Used with SFileOpenFileEx; only the archive with the handle specified will be searched for the file
#define SFILE_SEARCH_ALL_OPEN     0x01 //SFileOpenFileEx will look through all open archives for the file

#define MPQHANDLE HANDLE

// Storm function prototypes
BOOL  STORM WINAPI SFileOpenArchive(LPCSTR lpFileName, DWORD dwPriority, DWORD dwFlags, MPQHANDLE *hMPQ);
BOOL  STORM WINAPI SFileCloseArchive(MPQHANDLE hMPQ);
BOOL  STORM WINAPI SFileGetArchiveName(MPQHANDLE hMPQ, LPCSTR lpBuffer, DWORD dwBufferLength);
BOOL  STORM WINAPI SFileOpenFile(LPCSTR lpFileName, MPQHANDLE *hFile);
BOOL  STORM WINAPI SFileOpenFileEx(MPQHANDLE hMPQ, LPCSTR lpFileName, DWORD dwSearchScope, MPQHANDLE *hFile);
BOOL  STORM WINAPI SFileCloseFile(MPQHANDLE hFile);
DWORD STORM WINAPI SFileGetFileSize(MPQHANDLE hFile, LPDWORD lpFileSizeHigh);
BOOL  STORM WINAPI SFileGetFileArchive(MPQHANDLE hFile, MPQHANDLE *hMPQ);
BOOL  STORM WINAPI SFileGetFileName(MPQHANDLE hFile, LPCSTR lpBuffer, DWORD dwBufferLength);
DWORD STORM WINAPI SFileSetFilePointer(MPQHANDLE hFile, long lDistanceToMove, PLONG lplDistanceToMoveHigh, DWORD dwMoveMethod);
BOOL  STORM WINAPI SFileReadFile(MPQHANDLE hFile,LPVOID lpBuffer,DWORD nNumberOfBytesToRead,LPDWORD lpNumberOfBytesRead,LPOVERLAPPED lpOverlapped);
LCID  STORM WINAPI SFileSetLocale(LCID nNewLocale);
BOOL  STORM WINAPI SFileGetBasePath(LPCSTR lpBuffer, DWORD dwBufferLength);
BOOL  STORM WINAPI SFileSetBasePath(LPCSTR lpNewBasePath);

BOOL  STORM WINAPI SFileDestroy();

#ifdef __cplusplus
};  // extern "C" 
#endif

#endif

